;================================
; function refsel
; F. Heitsch, Mar 1999
;================================

function refsel,data,n,ny=ny,frac,cutedge=cutedge,debug=debug

;reforms 3D-array into 2D
;input     data   : 2D-array
;          n      : dimension of data
;          dir    : direction for reforming
;          sl     : slice number
;          frac   : fraction of points to be kept
;          cutedge: prevents overspilling of vectors

  n1 = n
  n2 = n
  if keyword_set(ny) then n2 = ny

  out = fltarr(n1,n2)
  out = data

  for j=0,n2-1 do begin
    for i=0,n1-1 do begin
      if (i mod frac ne 0) and (j mod frac ne frac/2) then begin 
        out(i,j) = 1.0e9
      endif
      if (i mod frac ne frac/2) and (j mod frac ne 0) then begin 
        out(i,j) = 1.0e9
      endif
      if keyword_set(cutedge) then begin
        if (   (i eq 0)         or (j eq 0) $
            or (i ge n1-frac/2) or (j ge n2-frac/2)) then begin 
          out(i,j) = 1.0e9
        endif
      endif
    endfor
  endfor

return,out
end
